"""

:Author: Franziska Koehn
:Created: 2015/01/26

This module houses classes relating to the GUI-representation of the additional data (like fields of questionnaires)

"""

import gtk

class AdddataView(gtk.VBox):
    """Container with all widgets for working with some additional data."""

    def __init__(self):
        """Creates area."""

        super(AdddataView, self).__init__()

        hbox_formula =  gtk.HBox()
        self.pack_start(hbox_formula, False, True, 0)

        label_user =  gtk.Label()
        label_user.set_text("Filter: ")
        hbox_formula.pack_start(label_user, False, True, 0)

        entry_formula = gtk.Entry()
        entry_formula.set_text("field0 == \"test\" or field1 < 2")
        hbox_formula.pack_start(entry_formula, True, True, 0)

        sw_results = gtk.ScrolledWindow()
        sw_results.set_shadow_type(gtk.SHADOW_ETCHED_IN)
        sw_results.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.pack_start(sw_results, True, True, 0)

        self.treeview_results = TreeViewResults()
        sw_results.add(self.treeview_results)


    def show_comparison(self, root_type, table):
        self.treeview_results.show_data(root_type, table)

class TreeViewResults(gtk.TreeView):

    def __init__(self):
        super(TreeViewResults, self).__init__()


    def show_data(self, root_type, table):
        if table == []:
            return
        self.create_columns(root_type, table.headers())
        self.create_model(table)


    def create_columns(self, root_type, column_names):
        import xsa.datatypereader

        for c in self.get_columns():
            self.remove_column(c)

        for i,key in enumerate(column_names, start=1):
            cname = xsa.datatypereader.get_field_label_by_key(root_type, key)
            column = gtk.TreeViewColumn(cname, gtk.CellRendererText(), text=i)
            column.set_sort_column_id(i)
            column.set_resizable(True)
            self.append_column(column)


    def create_model(self, table):
        import gobject

        model_columns = []
        model_columns.append(gobject.TYPE_PYOBJECT) # 0 data-set
        for column in table.headers():
            model_columns.append(str)               # 1..* values for chosen columns
        store = gtk.ListStore(*model_columns)

        for row in table:
            row_data=[]
            row_data.append(row)
            for h in table.headers():
                row_data.append(row[h])
            store.append(row_data)

        self.set_model(store)
